#include <stdio.h>
#include "IFirstXpcom.h"
#include "nsIGenericFactory.h"
#include "nsStringAPI.h"

class FirstXpcom : public IFirstXpcom
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_IFIRSTXPCOM

  FirstXpcom();

private:
  ~FirstXpcom();

protected:
	nsString mName;
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(FirstXpcom, IFirstXpcom)

FirstXpcom::FirstXpcom()
{
  /* member initializers and constructor code */
	mName.Assign(L"FirstXpcom Component");
}

FirstXpcom::~FirstXpcom()
{
  /* destructor code */
}

/* attribute AString name; */
NS_IMETHODIMP FirstXpcom::GetName(nsAString & aName)
{
    aName.Assign(mName);
	printf("FirstXpcom::GetName\n");
	return NS_OK;
}
NS_IMETHODIMP FirstXpcom::SetName(const nsAString & aName)
{
    mName.Assign(aName);
	printf("FirstXpcom::SetName\n");
	return NS_OK;
}

/* long add (in long a, in long b); */
NS_IMETHODIMP FirstXpcom::Add(PRInt32 a, PRInt32 b, PRInt32 *_retval)
{
	printf("FirstXpcom::Add(%d, %d)",a ,b);
	*_retval = a + b;
	return NS_OK;
}

// This will result in a function named FirstXpcomConstructor.
NS_GENERIC_FACTORY_CONSTRUCTOR(FirstXpcom)

// e81efbdf-8461-464b-b876-f0a45d6bfaf8 
#define FIRSTXPCOM_CID \
  {0xe81efbdf, 0x8461, 0x464b, \
      { 0xb8, 0x76, 0xf0, 0xa4, 0x5d, 0x6b, 0xfa, 0xf8} }

static const nsModuleComponentInfo components[] =
{
  { "FirstXpcom",
    FIRSTXPCOM_CID,
    "@senecac.on.ca/firstxpcom;1",
    FirstXpcomConstructor
  }
};

NS_IMPL_NSGETMODULE(FirstXpcomModule, components)